from bot_api.abc.dto_abc import DtoABC


class TokenDTO(DtoABC):
    def __init__(self, token: str, refresh_token: str, first_login: bool = False):
        DtoABC.__init__(self)

        self._token = token
        self._refresh_token = refresh_token
        self._first_login = first_login

    @property
    def token(self) -> str:
        return self._token

    @property
    def refresh_token(self) -> str:
        return self._refresh_token

    @property
    def first_login(self) -> bool:
        return self._first_login

    def from_dict(self, values: dict):
        self._token = values["token"]
        self._refresh_token = values["refreshToken"]
        self._first_login = values["firstLogin"]

    def to_dict(self) -> dict:
        return {"token": self._token, "refreshToken": self._refresh_token, "firstLogin": self._first_login}
