from abc import ABC, abstractmethod

from cpl_query.extension import List

from bot_data.model.game_server import GameServer


class GameServerRepositoryABC(ABC):
    @abstractmethod
    def __init__(self):
        pass

    @abstractmethod
    def get_game_servers(self) -> List[GameServer]:
        pass

    @abstractmethod
    def get_game_server_by_id(self, id: int) -> GameServer:
        pass

    @abstractmethod
    def get_game_servers_by_server_id(self, id: int) -> List[GameServer]:
        pass

    @abstractmethod
    def get_game_server_by_api_key_id(self, id: int) -> GameServer:
        pass

    @abstractmethod
    def add_game_server(self, game_server: GameServer):
        pass

    @abstractmethod
    def update_game_server(self, game_server: GameServer):
        pass

    @abstractmethod
    def delete_game_server(self, game_server: GameServer):
        pass
