CREATE TABLE IF NOT EXISTS `CFG_TechnicianPingUrlsHistory`
(
    `Id`    BIGINT(20)  NOT NULL,
    `URL` VARCHAR(255) NOT NULL,
    `Deleted` BOOL DEFAULT FALSE,
    `DateFrom` DATETIME(6) NOT NULL,
    `DateTo` DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_CFG_TechnicianPingUrlsUpdate`;

CREATE TRIGGER `TR_CFG_TechnicianPingUrlsUpdate`
    AFTER UPDATE
    ON `CFG_TechnicianPingUrls`
    FOR EACH ROW
BEGIN
    INSERT INTO `CFG_TechnicianPingUrlsHistory` (
        `Id`,
        `URL`,
        `DateFrom`,
        `DateTo`
    )
    VALUES (
        OLD.Id,
        OLD.URL,
        OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_CFG_TechnicianPingUrlsDelete`;

CREATE TRIGGER `TR_CFG_TechnicianPingUrlsDelete`
    AFTER DELETE
    ON `CFG_TechnicianPingUrls`
    FOR EACH ROW
BEGIN
    INSERT INTO `CFG_TechnicianPingUrlsHistory` (
        `Id`,
        `URL`,
        `Deleted`,
        `DateFrom`,
        `DateTo`
    )
    VALUES (
        OLD.Id,
        OLD.URL,
        TRUE,
        OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;