ALTER TABLE `Servers`
    CHANGE `CreatedAt` `CreatedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `Servers`
    CHANGE `LastModifiedAt` `LastModifiedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `ServersHistory`
(
    `Id`        BIGINT(20)  NOT NULL,
    `DiscordId` BIGINT(20)  NOT NULL,
    `Deleted`         BOOL DEFAULT FALSE,
    `DateFrom`        DATETIME(6) NOT NULL,
    `DateTo`          DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_ServersUpdate`;

CREATE TRIGGER `TR_ServersUpdate`
    AFTER UPDATE
    ON `Servers`
    FOR EACH ROW
BEGIN
    INSERT INTO `ServersHistory` (
        `Id`, `DiscordId`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.ServerId, OLD.DiscordServerId, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_ServersDelete`;

CREATE TRIGGER `TR_ServersDelete`
    AFTER DELETE
    ON `Servers`
    FOR EACH ROW
BEGIN
    INSERT INTO `ServersHistory` (
        `Id`, `DiscordId`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.ServerId, OLD.DiscordServerId, TRUE, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;