from bot_data.abc.history_table_abc import HistoryTableABC


class ServerConfigHistory(HistoryTableABC):
    def __init__(
        self,
        message_delete_timer: int,
        notification_chat_id: int,
        max_voice_state_hours: int,
        xp_per_message: int,
        xp_per_reaction: int,
        max_message_xp_per_hour: int,
        xp_per_ontime_hour: int,
        xp_per_event_participation: int,
        xp_per_achievement: int,
        afk_command_channel_id: int,
        help_voice_channel_id: int,
        team_channel_id: int,
        login_message_channel_id: int,
        feature_flags: dict[str],
        server_id: int,
        deleted: bool,
        date_from: str,
        date_to: str,
        id=0,
    ):
        HistoryTableABC.__init__(self)

        self._id = id
        self._message_delete_timer = message_delete_timer
        self._notification_chat_id = notification_chat_id
        self._max_voice_state_hours = max_voice_state_hours
        self._xp_per_message = xp_per_message
        self._xp_per_reaction = xp_per_reaction
        self._max_message_xp_per_hour = max_message_xp_per_hour
        self._xp_per_ontime_hour = xp_per_ontime_hour
        self._xp_per_event_participation = xp_per_event_participation
        self._xp_per_achievement = xp_per_achievement
        self._afk_command_channel_id = afk_command_channel_id
        self._help_voice_channel_id = help_voice_channel_id
        self._team_channel_id = team_channel_id
        self._login_message_channel_id = login_message_channel_id
        self._feature_flags = feature_flags
        self._server_id = server_id

        self._deleted = deleted
        self._date_from = date_from
        self._date_to = date_to

    @property
    def message_delete_timer(self) -> int:
        return self._message_delete_timer

    @property
    def notification_chat_id(self) -> int:
        return self._notification_chat_id

    @property
    def max_voice_state_hours(self) -> int:
        return self._max_voice_state_hours

    @property
    def xp_per_message(self) -> int:
        return self._xp_per_message

    @property
    def xp_per_reaction(self) -> int:
        return self._xp_per_reaction

    @property
    def max_message_xp_per_hour(self) -> int:
        return self._max_message_xp_per_hour

    @property
    def xp_per_ontime_hour(self) -> int:
        return self._xp_per_ontime_hour

    @property
    def xp_per_event_participation(self) -> int:
        return self._xp_per_event_participation

    @property
    def xp_per_achievement(self) -> int:
        return self._xp_per_achievement

    @property
    def afk_command_channel_id(self) -> int:
        return self._afk_command_channel_id

    @property
    def help_voice_channel_id(self) -> int:
        return self._help_voice_channel_id

    @property
    def team_channel_id(self) -> int:
        return self._team_channel_id

    @property
    def login_message_channel_id(self) -> int:
        return self._login_message_channel_id

    @property
    def feature_flags(self) -> dict[str]:
        return self._feature_flags

    @property
    def server_id(self) -> int:
        return self._server_id
