from datetime import datetime

from cpl_core.database import TableABC

from bot_data.model.game_server import GameServer
from bot_data.model.user import User


class UserGameIdent(TableABC):
    def __init__(
        self,
        user: User,
        game_server: GameServer,
        ident: str,
        created_at: datetime = None,
        modified_at: datetime = None,
        id=0,
    ):
        self._id = id
        self._user = user
        self._game_server = game_server
        self._ident = ident

        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @property
    def id(self) -> int:
        return self._id

    @property
    def user(self) -> User:
        return self._user

    @property
    def game_server(self) -> GameServer:
        return self._game_server

    @property
    def ident(self) -> str:
        return self._ident

    @staticmethod
    def get_select_all_string() -> str:
        return str(
            f"""
            SELECT * FROM `UserGameIdents`;
        """
        )

    @staticmethod
    def get_select_by_id_string(id: int) -> str:
        return str(
            f"""
            SELECT * FROM `UserGameIdents`
            WHERE `Id` = {id};
        """
        )

    @staticmethod
    def get_select_by_ident_string(ident: str) -> str:
        return str(
            f"""
            SELECT * FROM `UserGameIdents`
            WHERE `Ident` = '{ident}';
        """
        )

    @staticmethod
    def get_select_by_user_id_string(id: int) -> str:
        return str(
            f"""
            SELECT * FROM `UserGameIdents`
            WHERE `UserId` = {id};
        """
        )

    @staticmethod
    def get_select_active_by_user_id_string(id: int) -> str:
        return str(
            f"""
            SELECT * FROM `UserGameIdents`
            WHERE `UserId` = {id}
            AND `LeavedOn` IS NULL;
        """
        )

    @property
    def insert_string(self) -> str:
        return str(
            f"""
            INSERT INTO `UserGameIdents` (
                `UserId`, `GameServerId`, `Ident`
            ) VALUES (
                {self._user.id},
                '{self._game_server.id}',
                '{self._ident}'
            );
        """
        )

    @property
    def udpate_string(self) -> str:
        return ""

    @property
    def delete_string(self) -> str:
        return str(
            f"""
            DELETE FROM `UserGameIdents`
            WHERE `Id` = {self._id};
        """
        )

    @staticmethod
    def delete_by_user_id_string(id: int) -> str:
        return str(
            f"""
            DELETE FROM `UserGameIdents`
            WHERE `UserId` = {id}
    """
        )
