from cpl_query.extension import List

from bot_data.model.server import Server


class CacheService:
    def __init__(self):
        self._cached_servers = List(Server)

    @property
    def cached_server(self) -> List[Server]:
        return self._cached_servers

    def add_server(self, server: Server):
        if self._cached_servers.where(lambda x: x.id == server.id).count() > 0:
            return
        self._cached_servers.add(server)

    def add_servers(self, servers: List[Server]):
        new_ids = servers.select(lambda x: x.id)
        for s in self._cached_servers:
            if s.id in new_ids:
                return

        self._cached_servers.extend(servers)
