import traceback

from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_core.console import Console


class PostBuildSettings(ConfigurationModelABC):
    def __init__(self):
        ConfigurationModelABC.__init__(self)

        self._keep_config = []
        self._config_paths = []

    @property
    def keep_config(self) -> list[str]:
        return self._keep_config

    @property
    def config_paths(self) -> list[str]:
        return self._config_paths

    def from_dict(self, settings: dict):
        try:
            self._keep_config = settings["KeepConfigs"]
            self._config_paths = settings["ConfigPaths"]
        except Exception as e:
            Console.error(f"[ ERROR ] [ {__name__} ]: Reading error in {type(self).__name__} settings")
            Console.error(f"[ EXCEPTION ] [ {__name__} ]: {e} -> {traceback.format_exc()}")
